MODULE_NAME='M_Samsung, iTV, COMM, REV01' (DEV vdviTV, DEV dviTV)
(*{{PS_SOURCE_INFO(PROGRAM STATS)                          *)
(***********************************************************)
(*  FILE CREATED ON: 09/23/2009 AMT: 8:17:00               *)
(***********************************************************)
(*  FILE_LAST_MODIFIED_ON: 09/23/2009 AMT: 8:17:00         *)
(***********************************************************)
(*  ORPHAN_FILE_PLATFORM: 1                                *)
(***********************************************************)
(*!!FILE REVISION:                                         *)
(*  REVISION DATE: 09/23/2009                              *)
(*                                                         *)
(*  COMMENTS:                                              *)
(*                                                         *)
(***********************************************************)
(*}}PS_SOURCE_INFO                                         *)
(***********************************************************)
(************************************************************************)
(* System Type :                                          23.09.2009BR  *)
(*                                                                      *)
(*                                                                      *)
(************************************************************************)

(************************************************************************)
(*          DEVICE NUMBER DEFINITIONS GO BELOW                          *)
(************************************************************************)
DEFINE_DEVICE

#INCLUDE 'SNAPI.AXI'

(************************************************************************)
(*               CONSTANT DEFINITIONS GO BELOW                          *)
(************************************************************************)
DEFINE_CONSTANT

(************************************************************************)
(*              DATA TYPE DEFINITIONS GO BELOW                          *)
(************************************************************************)
DEFINE_TYPE

(************************************************************************)
(* BEGIN DEFINE_TYPE SERVER                                 03.11.09 BA *)
(************************************************************************)

STRUCTURE _ServerInfo
  {
  CHAR cIPAdresse[30]			// TCP/IP-Adresse von NSP-1
  INTEGER nIPPort     			// TCP/IP-Port von NSP-1 als String
  INTEGER nIPProt      			// TCP/IP-Protocol 1= TCP/IP, 2= UDP
  }

(************************************************************************)
(* ENDE  DEFINE_TYPE SERVER                                 03.11.09 BA *)
(************************************************************************)

(************************************************************************)
(*               VARIABLE DEFINITIONS GO BELOW                          *)
(************************************************************************)
DEFINE_VARIABLE

(************************************************************************)
(* BEGIN VARIABLE SERVER                                    03.11.09 BA *)
(************************************************************************)

_ServerInfo ServerInfo			// Enthlt Info von Server

INTEGER nConnectedToServer		// True when Server Online
INTEGER nConnect

(************************************************************************)
(* ENDE  VARIABLE SERVER                                    03.11.09 BA *)
(************************************************************************)


nDebug

CHAR cStack[1000]                    // Stack AV Receiver
INTEGER nSendReady			// True Wenn Sendeerlaubnis
CHAR cInputBuffer[1000]

CHAR cStringTable[200][20]	// Contains the Strings to send
CHAR cModelName[20]
CHAR cControllerName[20]


(************************************************************************)
(*               LATCHING DEFINITIONS GO BELOW                          *)
(************************************************************************)
DEFINE_LATCHING

(************************************************************************)
(*       MUTUALLY EXCLUSIVE DEFINITIONS GO BELOW                        *)
(************************************************************************)
DEFINE_MUTUALLY_EXCLUSIVE

(************************************************************************)
(*        SUBROUTINE/FUNCTION DEFINITIONS GO BELOW                      *)
(************************************************************************)

(************************************************************************)
(*        SUBROUTINE/FUNCTION DEFINITIONS GO BELOW         		*)
(************************************************************************)

DEFINE_FUNCTION CHAR[100] GET_IP_ERROR (LONG lERR)
  {
  SELECT
    {
    ACTIVE (lERR = 0):
      RETURN "";
    ACTIVE (lERR = 2):
      RETURN "'IP ERROR (',ITOA(lERR),'): General Failure (IP_CLIENT_OPEN/IP_SERVER_OPEN)'";
    ACTIVE (lERR = 4):
      RETURN "'IP ERROR (',ITOA(lERR),'): unknown host (IP_CLIENT_OPEN)'";
    ACTIVE (lERR = 6):
      RETURN "'IP ERROR (',ITOA(lERR),'): connection refused (IP_CLIENT_OPEN)'";
    ACTIVE (lERR = 7):
      RETURN "'IP ERROR (',ITOA(lERR),'): connection timed out (IP_CLIENT_OPEN)'";
    ACTIVE (lERR = 8):
      RETURN "'IP ERROR (',ITOA(lERR),'): unknown connection error (IP_CLIENT_OPEN)'";
    ACTIVE (lERR = 14):
      RETURN "'IP ERROR (',ITOA(lERR),'): local port already used (IP_CLIENT_OPEN/IP_SERVER_OPEN)'";
    ACTIVE (lERR = 16):
      RETURN "'IP ERROR (',ITOA(lERR),'): too many open sockets (IP_CLIENT_OPEN/IP_SERVER_OPEN)'";
    ACTIVE (lERR = 10):
      RETURN "'IP ERROR (',ITOA(lERR),'): Binding error (IP_SERVER_OPEN)'";
    ACTIVE (lERR = 11):
      RETURN "'IP ERROR (',ITOA(lERR),'): Listening error (IP_SERVER_OPEN)'";
    ACTIVE (lERR = 15):
      RETURN "'IP ERROR (',ITOA(lERR),'): UDP socket already listening (IP_SERVER_OPEN)'";
    ACTIVE (lERR = 9):
      RETURN "'IP ERROR (',ITOA(lERR),'): Already closed (IP_CLIENT_CLOSE/IP_SERVER_CLOSE)'";
    ACTIVE (1):
      RETURN "'IP ERROR (',ITOA(lERR),'): Unknown'";
//      IP_CLIENT_CLOSE(dvDSP____1.Port)
    }
  }

DEFINE_FUNCTION fStackWrite (CHAR cDFSWString[100])
  {
  cStack="cStack,'START',$00,(LENGTH_STRING(cControllerName)+LENGTH_STRING(cModelName)+14),$00,
		 cControllerName,'.',cModelName,'.iapp.samsung',
		 $0D,$00,$00,$00,$00,LENGTH_STRING(cDFSWString),$00,cDFSWString,'END'"
  }
 
DEFINE_FUNCTION fStackRead ()
  {
  LOCAL_VAR CHAR cStackReadStr[255]
  IF(FIND_STRING(cStack,"'END'",1))			// Find Endbyte
    {
    cStackReadStr=REMOVE_STRING(cStack,"'END'",1)	// Cut string from stack	
    IF(FIND_STRING(cStackReadStr,"'START'",1))		// Find Startbyte
      {
      REMOVE_STRING(cStackReadStr,"'START'",1)		// Cut out Startbyte
      SET_LENGTH_STRING(cStackReadStr,LENGTH_STRING(cStackReadStr)-3)
      nSendReady=0					// True if send ready
      SEND_STRING dviTV,"cStackReadStr"		// Send string 
      IF(nDebug)
        {
        SEND_STRING 5001:2:0,"cStackReadStr"		// Send string 
	}
      }
    }
  }  



(************************************************************************)
(*                STARTUP CODE GOES BELOW                               *)
(************************************************************************)
DEFINE_START

SET_VIRTUAL_CHANNEL_COUNT(vdviTV,2000)

cControllerName='AMX'
cModelName='UE46C6800'

cStringTable[001]="'S0VZX1BMQVk='"
cStringTable[002]="'S0VZX1NUT1A='"
cStringTable[003]="'S0VZX1BBVVNF'"
cStringTable[004]="'S0VZX0ZG'"
cStringTable[005]="'S0VZX1JFV0lORA=='"
//cStringTable[006]="'S0VZXzU='"
//cStringTable[007]="'S0VZXzU='"
cStringTable[008]="'S0VZX1JFQw=='"
cStringTable[009]="'S0VZX1BPV0VST0ZG'"
cStringTable[010]="'S0VZXzA='"
cStringTable[011]="'S0VZXzE='"
cStringTable[012]="'S0VZXzI='"
cStringTable[013]="'S0VZXzM='"
cStringTable[014]="'S0VZXzQ='"
cStringTable[015]="'S0VZXzU='"
cStringTable[016]="'S0VZXzY='"
cStringTable[017]="'S0VZXzc='"
cStringTable[018]="'S0VZXzg='"
cStringTable[019]="'S0VZXzk='"
//cStringTable[020]="'S0VZXzU='"
//cStringTable[021]="'S0VZXzU='"
cStringTable[022]="'S0VZX0NIVVA='"
cStringTable[023]="'S0VZX0NIRE9XTg=='"
cStringTable[024]="'S0VZX1ZPTFVQ'"
cStringTable[025]="'S0VZX1ZPTERPV04='"
cStringTable[026]="'S0VZX01VVEU='"
//cStringTable[027]="'S0VZXzU='"
//cStringTable[028]="'S0VZXzU='"
//cStringTable[029]="'S0VZXzU='"
cStringTable[030]="'S0VZX1NPVVJDRQ=='"
//cStringTable[031]="'S0VZXzU='"
//cStringTable[032]="'S0VZXzU='"
//cStringTable[033]="'S0VZXzU='"
//cStringTable[034]="'S0VZXzU='"
//cStringTable[035]="'S0VZXzU='"
//cStringTable[036]="'S0VZXzU='"
//cStringTable[037]="'S0VZXzU='"
//cStringTable[038]="'S0VZXzU='"
//cStringTable[039]="'S0VZXzU='"
//cStringTable[040]="'S0VZXzU='"
//cStringTable[041]="'S0VZXzU='"
//cStringTable[042]="'S0VZXzU='"
//cStringTable[043]="'S0VZXzU='"
//cStringTable[044]="'S0VZXzU='"
//cStringTable[045]="'S0VZXzU='"
//cStringTable[046]="'S0VZXzU='"
//cStringTable[047]="'S0VZXzU='"
//cStringTable[048]="'S0VZXzU='"
//cStringTable[049]="'S0VZXzU='"
//cStringTable[050]="'S0VZXzU='"
//cStringTable[051]="'S0VZXzU='"
//cStringTable[052]="'S0VZXzU='"
//cStringTable[053]="'S0VZXzU='"
//cStringTable[054]="'S0VZXzU='"
//cStringTable[055]="'S0VZXzU='"
//cStringTable[056]="'S0VZXzU='"
//cStringTable[057]="'S0VZXzU='"
//cStringTable[058]="'S0VZXzU='"
//cStringTable[059]="'S0VZXzU='"
//cStringTable[060]="'S0VZXzU='"
//cStringTable[061]="'S0VZXzU='"
//cStringTable[062]="'S0VZXzU='"
//cStringTable[063]="'S0VZXzU='"
//cStringTable[064]="'S0VZXzU='"
//cStringTable[065]="'S0VZXzU='"
//cStringTable[066]="'S0VZXzU='"
//cStringTable[067]="'S0VZXzU='"
//cStringTable[068]="'S0VZXzU='"
//cStringTable[069]="'S0VZXzU='"
//cStringTable[070]="'S0VZXzU='"
//cStringTable[071]="'S0VZXzU='"
//cStringTable[072]="'S0VZXzU='"
//cStringTable[073]="'S0VZXzU='"
//cStringTable[074]="'S0VZXzU='"
//cStringTable[075]="'S0VZXzU='"
//cStringTable[076]="'S0VZXzU='"
//cStringTable[077]="'S0VZXzU='"
//cStringTable[078]="'S0VZXzU='"
//cStringTable[079]="'S0VZXzU='"
//cStringTable[080]="'S0VZXzU='"
//cStringTable[081]="'S0VZXzU='"
//cStringTable[082]="'S0VZXzU='"
//cStringTable[083]="'S0VZXzU='"
//cStringTable[084]="'S0VZXzU='"
//cStringTable[085]="'S0VZXzU='"
//cStringTable[086]="'S0VZXzU='"
//cStringTable[087]="'S0VZXzU='"
//cStringTable[088]="'S0VZXzU='"
//cStringTable[089]="'S0VZXzU='"
//cStringTable[090]="'S0VZXzU='"
//cStringTable[091]="'S0VZXzU='"
//cStringTable[092]="'S0VZXzU='"
//cStringTable[093]="'S0VZXzU='"
//cStringTable[094]="'S0VZXzU='"
//cStringTable[095]="'S0VZXzU='"
//cStringTable[096]="'S0VZXzU='"
//cStringTable[097]="'S0VZXzU='"
//cStringTable[098]="'S0VZXzU='"
//cStringTable[099]="'S0VZXzU='"
//cStringTable[100]="'S0VZXzU='"
//cStringTable[101]="'S0VZXzU='"
//cStringTable[102]="'S0VZXzU='"
//cStringTable[103]="'S0VZXzU='"
cStringTable[104]="'S0VZX1JFVFVSTg=='"	// Return
//cStringTable[105]="'S0VZXzU='"
//cStringTable[106]="'S0VZXzU='"
//cStringTable[107]="'S0VZXzU='"
//cStringTable[108]="'S0VZXzU='"
//cStringTable[109]="'S0VZXzU='"
//cStringTable[110]="'S0VZXzU='"

(************************************************************************)
(* BEGIN DEFINE_START SERVER                                03.11.09 BA *)
(************************************************************************)

ServerInfo.cIPAdresse=''		// TCP/IP-Adresse von Biamp
ServerInfo.nIPPort=55000		// TCP/IP-Port
ServerInfo.nIPProt=IP_TCP		// TCP/IP-Protocol 1= TCP/IP, 2= UDP

(************************************************************************)
(* ENDE  DEFINE_START SERVER                                03.11.09 BA *)
(************************************************************************)

(************************************************************************)
(* START DEFINE_START COMBINE_DEVICES                                   *)
(************************************************************************)


(************************************************************************)
(* ENDE  DEFINE_START COMBINE_DEVICES                                   *)
(************************************************************************)


(************************************************************************)
(*                THE EVENTS GOES BELOW                                 *)
(************************************************************************)
DEFINE_EVENT


DATA_EVENT[dviTV]
  {
  ONERROR:
    {
    SEND_STRING 0,GET_IP_ERROR (DATA.NUMBER)
    }    
  ONLINE:
    {
    ON [nConnectedToServer]		// True when Server Online
    SEND_STRING dviTV,"$00,$11,$00,		// Connect to TV
		       'AMX..iapp.samsung<',
		       $00,$64,$00,$10,$00,
		       'MTkyLjE2OC4xLjUx',
		       $18,$00,
		       'RDgtQTItNUUtNzYtNzYtNDM='
		       ,$0C,$00,'VG91Y2ggSXQ='"
//    SEND_STRING 5001:2:0,"$00,$11,$00,		// Connect to TV
//		       'AMX..iapp.samsung<',
//		       $00,$64,$00,$10,$00,
//		       'MTkyLjE2OC4xLjUx',
//		       $18,$00,
//		       'RDgtQTItNUUtNzYtNzYtNDM='
//		       ,$0C,$00,'VG91Y2ggSXQ='"
    }
  STRING:
    {
    LOCAL_VAR cString[1024]
    cString=DATA.TEXT
//    SEND_STRING 5001:1:0,cString
//    CANCEL_WAIT 'TimeoutAVR'
//    WAIT 4
//      {
      nSendReady=1
//      }
    }
  OFFLINE:
    {
    OFF[nConnectedToServer]		// True when Server Online
    }    
  }

DATA_EVENT[vdviTV]
  {
  COMMAND:
    {
    LOCAL_VAR CHAR cBuffer[100]
  
    cBuffer=DATA.TEXT
    SELECT
      {
      ACTIVE(FIND_STRING(cBuffer,"'CONNECT-'",1)):	// Set IP Adress
        {
	LOCAL_VAR CHAR cBuffer2[100]	// Buffer 2
	cBuffer2=cBuffer
	REMOVE_STRING(cBuffer2,"'-'",1)
	nConnect=ATOI(cBuffer2)
	}
      ACTIVE(FIND_STRING(cBuffer,"'TV_CHANNEL-'",1)):	// Set IP Adress
        {
	LOCAL_VAR CHAR cBuffer2[100]	// Buffer 2
	LOCAL_VAR INTEGER nTVNumber
	cBuffer2=cBuffer
	REMOVE_STRING(cBuffer2,"'-'",1)
	nTVNumber=ATOI(cBuffer2)
	fStackWrite(cStringTable[(nTVNumber/1000)+10])
	fStackWrite(cStringTable[((nTVNumber/100)%10)+10])
	fStackWrite(cStringTable[((nTVNumber/10)%10)+10])
	fStackWrite(cStringTable[(nTVNumber%10)+10])
	}
      ACTIVE(FIND_STRING(cBuffer,"'IP_ADRESS-'",1)):	// Set IP Adress
        {
	LOCAL_VAR CHAR cBuffer2[100]	// Buffer 2
	cBuffer2=cBuffer
	REMOVE_STRING(cBuffer2,"'-'",1)
	ServerInfo.cIPAdresse=cBuffer2
	}
      }
    }
  }

CHANNEL_EVENT[vdviTV,000]
  {
  ON:
    {
    fStackWrite(cStringTable[CHANNEL.CHANNEL])
    }
  }


(************************************************************************)
(* END DEFINE_EVENT Denon Receiver	                  12.08.2009 BA *)
(************************************************************************)


(************************************************************************)
(*            THE ACTUAL PROGRAM GOES BELOW                             *)
(************************************************************************)
DEFINE_PROGRAM

IF((!nConnectedToServer) AND (LENGTH_STRING(ServerInfo.cIPAdresse)) AND nConnect) 
  {
  IP_CLIENT_OPEN (dviTV.Port,ServerInfo.cIPAdresse ,ServerInfo.nIPPort,ServerInfo.nIPProt)
  }

IF(LENGTH_STRING(cStack) AND nSendReady)	// berprfe Stacklnge und Sendeerlaubnis
  {
  fStackRead()
  }

WAIT 40 'Timeout'
  {
  nSendReady=1					// True wenn Sendeerlaubnis
  }



(************************************************************************)
(*                     END OF PROGRAM                                   *)
(*        DO NOT PUT ANY CODE BELOW THIS COMMENT                        *)
(************************************************************************)